#!/usr/bin/env python3
import sys, tracemalloc

from IzzyLib import logging

from .web_server import start
from .config import config
from .database import db


with db.session() as s:
	version = s.get.version()

	if not version:
		logging.error('Database is not setup. Run "python3 -m social.manage setup" to configure the server.')
		sys.exit()


if config.env == 'dev':
	tracemalloc.start()


start()
