from sanic.views import HTTPMethodView
from sanic.response import redirect

from ..database import db
from ..functions import JsonCheck, Error


# Redirect /user/[user] to /@[user]
class User(HTTPMethodView):
	async def get(self, request, user):
		return redirect(f'/@{user}')


# Redirect /status/[status] to /:[status]
class Post(HTTPMethodView):
	async def get(self, request, status):
		if JsonCheck(request.headers):
			return json_user(request, status)

		return redirect(f'/:{status}')


class About(HTTPMethodView):
	async def get(self, request):
		return redirect('/about')


class Admin(HTTPMethodView):
	async def get(self, request):
		with db.session() as s:
			admin = s.get.config('admin')

			if not admin:
				return redirect('/about')
				return Error(request, 404, 'Admin contact not set')

			account = s.get.user(admin)

			if not account:
				logging.error(f'views.redirects.Admin: Admin contact invalid: {admin}')
				return redirect('/about')

			return redirect(f'/@{account.handle}')


# PATPAT
class HeadPats(HTTPMethodView):
	async def get(self, request):
		return redirect('https://static.barkshark.xyz/mastodon/main/custom_emojis/images/000/000/797/original/blobpatpat.png')


#socks
class Socks(HTTPMethodView):
	async def get(self, request):
		return redirect('https://barkshark.xyz/@izalia/103155447990974282')

	async def socks_old(request):
		return redirect('https://glaceon.social/@monorail/102496098954435127')
